CREATE TABLE "person" (
  "id"                  serial8         primary key,
  "name"                text            not null );

CREATE TABLE "medium" (
  "number"              int8            primary key,
  "lent_to_id"        int8              references "person" ("id")
                                        on delete restrict on update cascade );

CREATE TABLE "movie" (
  "id"                  serial8         primary key,
  "name"                text            not null );

CREATE TABLE "medium_entry" (
  "medium_number"       int8            not null references "medium" ("number")
                                        on delete cascade on update cascade,
  "position"            int8            not null,
  "movie_id"            int8            not null
                                        references "movie" ("id")
                                        on delete restrict on update cascade,
  PRIMARY KEY ("medium_number", "position") );

CREATE TABLE "rating" (
  "person_id"           int8            not null
                                        references "person" ("id")
                                        on delete cascade on update cascade,
  "movie_id"            int8            not null
                                        references "movie" ("id")
                                        on delete cascade on update cascade,
  "rating"              numeric,
  "comment"             text,
  PRIMARY KEY ("person_id", "movie_id") );

